library ieee;
use ieee.std_logic_1164.all;
use work.GEN_CONST.all;

entity GENERATOR is
    port(CLK, RESET: in std_logic;
        D: out std_logic_vector(w - 1 DOWNTO 0));
end GENERATOR;

architecture GENERATOR_BODY of GENERATOR is

component NEGATOR
  port (A : in std_logic_vector(w-1 downto 0);
      Y : out std_logic_vector(w-1 downto 0));
end component;
component COUNTER
    port(CLK, RESET, UP: in std_logic;
         TOP, BOTTOM: out std_logic;
         CNT: out std_logic_vector(aw downto 0));
end component;
component MEMORY
    port(ADRESS: in std_logic_vector(aw downto 0);
         CONTENT: out std_logic_vector(w - 1 downto 0));
end component;
component CONTROLER
  port (CLK, RESET, TOP, BOTTOM : in std_logic;
      UP, SEL : out std_logic);
end component;
component MULTIPLEXER
  port (SEL : in std_logic;
      A,B : in std_logic_vector(w-1 downto 0);
      Y   : out std_logic_vector(w-1 downto 0));
end component;

signal T_CNT: std_logic_vector(aw downto 0);
signal T_CONT: std_logic_vector(w - 1 downto 0);
signal T_NEG: std_logic_vector(w - 1 downto 0);
signal T_UP: std_logic;
signal T_BOTTOM: std_logic;
signal T_TOP: std_logic;
signal T_SEL: std_logic;

begin
  cnt: COUNTER port map (CLK, RESET, T_UP, T_TOP, T_BOTTOM, T_CNT);
  mem: MEMORY port map (T_CNT, T_CONT);
  neg: NEGATOR port map (T_CONT, T_NEG);
  mult: MULTIPLEXER port map (T_SEL, T_NEG, T_CONT, D);
  cont: CONTROLER port map (CLK, RESET, T_TOP, T_BOTTOM, T_UP, T_SEL);
end;