library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.GEN_CONST.all;

entity HW3_TEST is
end HW3_TEST;

architecture TESTBENCH of HW3_TEST is

component GENERATOR
    port(CLK, RESET: in std_logic;
        D: out std_logic_vector(w - 1 DOWNTO 0));
end component;

signal T_OUT: std_logic_vector(w - 1 downto 0);
signal T_CLK: std_logic;
signal T_RESET: std_logic;

begin
    gen: GENERATOR port map (T_CLK, T_RESET, T_OUT);
  
    clock: PROCESS
    begin
        T_CLK <= '0';
        wait for 10 ns;
        T_CLK <= '1';
        wait for 10 ns;
    end process;
    
    res: process
    begin
        wait for 100 ns;
        T_RESET <= '1';
        wait for 20 ns;
        T_RESET <= '0';
        wait for 1000 ns;
        T_RESET <= '1';
        wait for 200 ns;
        T_RESET <= '0';
        wait;
    end process;
    
    test: process
       variable data: integer;
       variable up: integer;
    begin
        wait on T_CLK;
        if T_CLK = '1' then 
           if T_RESET = '0' then assert data = T_OUT report "data mismatch" severity warning;
                                 if up = 1 then data := data + 3;
                                                if data >= 27 then up := 0;
                                                end if;
                                 else data := data - 3;
                                      if data <= -27 then up := 1;
                                      end if;
                                 end if;
           else up := 1;
                data := 0;
           end if;
        end if;
    end process;

end TESTBENCH;